using System;
using System.Data.SqlClient;
using SvetoforVKBot.Models.Updates;
using VkNet;
using VkNet.Enums.SafetyEnums;
using VkNet.Model.Keyboard;
using VkNet.Model.RequestParams;
using System.Text.RegularExpressions;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using Newtonsoft.Json;
using System.Linq;

namespace SvetoforVKBot.Models.Commands.Registration
{
    public class SelectVyatsuRoleCommand : Command
    {
        public override string Name => "{\"button\":\"selectVyatsuRole-";

        public override void Execute(RootObject update, VkApi client, SvetoforVKBot.Data.SvetoforVKBotEntities db)
        {
        }

        public override void ExecutePL(RootObject update, VkApi client, SvetoforVKBot.Data.SvetoforVKBotEntities db)
        {
            var chatId = update.@object.message.from_id;
            MessagesSendParams @params = new MessagesSendParams();
            Regex regex = new Regex("[^0-9]");
            string msg = "";
            var keyboardBuilder = new KeyboardBuilder().Clear();
            int age = 0;
            int genderCoef = 0;
            double kkalResult = 0;
            double kkalResultLow = 0;
            double kkalResultHigh = 0;
            double colorPercent = 0;
            double dayCoef = 0;
            double curDayKkal = 0;
            SqlCommand editUser;
            try
            {
                string[] payload = update.@object.message.payload.Split('-');
                int vyatsuRole = Convert.ToInt32(regex.Replace(payload[1], ""));
                var userEdit = db.Users.Single(usr => usr.chatId == chatId);

                switch (vyatsuRole)
                {
                    case 1:
                        @params.Message = "Перечислите корпуса, в которых проходите обучение. Например: 1, 4.";
                        break;

                    case 2:
                        @params.Message = "Перечислите корпуса, в которых Вы работаете. Например: 1, 4.";
                        break;

                    case 3:
                        
                        userEdit.korpus = "0";
                        userEdit.statusId = vyatsuRole;
                        userEdit.tag = "Регистрация - Активность - Вид";
                        db.SaveChanges();
                        
                        @params.Message = "Вы заниматесь спортом или физкультурой?\n" +
                            "Выберите на клавиатуре вариант, который наиболее точно описывает Ваш образ жизни.\n\n" +
                            "👉🏻 Если Вы профессионально занимаетесь спортом или Ваша работа связана с тяжёлым физическим трудом, выберите вариант \"Занимаюсь спортом\"\n" +
                            "👉🏻 Если Вы не занимаетесь спортом профессионально, но регулярно поддерживаете физическую активность (занятия физкультурой), выберите вариант \"Занимаюсь физкультурой\"\n" +
                            "👉🏻 Если у Вас сидячая работа или нерегулярная физическая активность (менее одного раза в неделю), выберите вариант \"Ничем не занимаюсь\".\n";
                        keyboardBuilder
                            .AddButton("Занимаюсь спортом", "selectActivityKind-1", KeyboardButtonColor.Primary)
                            .AddLine()
                            .AddButton("Занимаюсь физкультурой", "selectActivityKind-2", KeyboardButtonColor.Primary)
                            .AddLine()
                            .AddButton("Ничем не занимаюсь", "selectActivityKind-3", KeyboardButtonColor.Primary)
                            .AddLine()
                            .AddButton("Отменить", "startPL", KeyboardButtonColor.Default);


                        @params.Keyboard = keyboardBuilder.Build();
                        @params.UserId = chatId;
                        @params.RandomId = GetRandomId();
                        client.Messages.SendAsync(@params);
                        return;

                }

                
                userEdit.statusId = vyatsuRole;
                userEdit.tag = "Регистрация - Корпус";
                db.SaveChanges();

                //@params.Message = "Напишите номер корпуса, в котором проходите обучение/работаете. Например: 1.";

                keyboardBuilder
                    .AddButton("Отменить", "startPL", KeyboardButtonColor.Default);

                @params.Keyboard = keyboardBuilder.Build();
                @params.UserId = chatId;
                @params.RandomId = GetRandomId();
                client.Messages.SendAsync(@params);
            }
            catch (Exception ee)
            {
                @params.Message = "‼Ошибка в SelectCalcCcalResultCommand: " + ee.Message;
                @params.Attachments = null;
                @params.Keyboard = null;
                @params.UserId = 59111081;
                @params.RandomId = GetRandomId();
                client.Messages.SendAsync(@params);
            }
        }
    }
}